//============================================================
//
//	video.h - Win32 implementation of MAME video routines
//
//============================================================

#ifndef __WIN_VIDEO__
#define __WIN_VIDEO__


//============================================================
//	PARAMETERS
//============================================================

// maximum video size
#define MAX_VIDEO_WIDTH			1600
#define MAX_VIDEO_HEIGHT		1200

enum
{
	FONT_COLOR_BLANK = 0,
	FONT_COLOR_NORMAL,
	FONT_COLOR_BLANK_INVERSE,
	FONT_COLOR_NORMAL_INVERSE,
	SYSTEM_COLOR_FRAMEMEDIUM,
	SYSTEM_COLOR_FRAMELIGHT,
	SYSTEM_COLOR_FRAMEDARK,
	BUTTON_COLOR_RED,
	BUTTON_COLOR_YELLOW,
	BUTTON_COLOR_GREEN,
	BUTTON_COLOR_BLUE,
	BUTTON_COLOR_PURPLE,
	BUTTON_COLOR_PINK,
	BUTTON_COLOR_AQUA,
	CURSOR_COLOR,
	ALT_BACKGROUND_COLOR,
	VOLUME_DARKRED,
	VOLUME_DARKYELLOW,
	VOLUME_DARKGREEN,
	JUKEBOX_BACKGROUND,
	MAX_COLORTABLE
};



//============================================================
//	GLOBAL VARIABLES
//============================================================

// current frameskip/autoframeskip settings
extern int			frameskip;
extern int			autoframeskip;

// gamma and brightness adjustments
extern float		gamma_correct;

// speed throttling
extern int			throttle;
extern int			game_speed_percent;

// palette lookups
extern UINT32 *		palette_16bit_lookup;
extern UINT32 *		palette_32bit_lookup;

// debugger palette
extern const UINT8 *dbg_palette;

// system memory
extern int			systemmemory;


//============================================================
//	PROTOTYPES
//============================================================

void win_mark_palette_dirty(void);


#endif
